'use strict';

var _api = require('./api');

var _nodebb = require('./nodebb');

var _backend = require('./backend');

var _backend2 = _interopRequireDefault(_backend);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _winston = require('winston');

var _winston2 = _interopRequireDefault(_winston);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Admin = module.exports = {};


Admin.init = function () {

  // Settings
  _nodebb.SocketAdmin.settings.syncMinecraftIntegration = function () {
    _config2.default.settings.sync(function () {
      _config2.default.logSettings();
    });
  };

  _nodebb.SocketAdmin.settings.resetMinecraftIntegration = function () {
    _config2.default.settings.reset(_config2.default.logSettings);
  };

  // ACP
  _nodebb.SocketAdmin.MinecraftIntegration = {};

  function addAdminSocket(name, func) {
    _nodebb.SocketAdmin.MinecraftIntegration[name] = function (socket, data, next) {
      func(data, function (err, data) {
        if (err) _winston2.default.error(err);
        next(err, data);
      });
    };
  }

  addAdminSocket('setServerConfig', _backend2.default.setServerConfig);
  addAdminSocket('getServersConfig', _backend2.default.getServersConfig);
  addAdminSocket('deleteUser', _api.deleteUser);
  addAdminSocket('refreshUser', _api.refreshUser);
  addAdminSocket('resetUsers', _api.resetUsers);
  addAdminSocket('deleteAvatar', _backend2.default.deleteAvatar);
  addAdminSocket('refreshAvatar', _backend2.default.refreshAvatar);
  addAdminSocket('resetAvatars', _backend2.default.resetAvatars);
  addAdminSocket('deletePlayer', _backend2.default.deletePlayer);
  // Uses fetchPlayer instead. addAdminSocket('refreshPlayer', Backend.refreshPlayer)
  // Doesn't exist. addAdminSocket('resetPlayers', Backend.resetPlayers)
  addAdminSocket('deleteServer', _backend2.default.deleteServer);
};