'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.eventWebChat = eventWebChat;
exports.eventPlayerChat = eventPlayerChat;

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

var _nodebb = require('../nodebb');

var _controller = require('../controller');

var _controller2 = _interopRequireDefault(_controller);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function eventWebChat(socket, data, next) {
  if (!(data && data.sid && data.name && data.message)) return next();

  var name = data.name,
      message = data.message,
      sid = data.sid;

  _nodebb.db.increment('mi:server:' + sid + ':cid', function (err, cid) {
    _nodebb.db.sortedSetAdd('mi:server:' + sid + ':cid:time', Date.now(), cid, function (err) {
      // TODO: Remove '[WEB]', add variable check.
      _nodebb.db.setObject('mi:server:' + sid + ':chat:' + cid, { name: '[WEB] ' + name, message: message }, function (err) {
        _controller2.default.sendPlayerChatToUsers({ sid: sid, chat: { name: '[WEB] ' + name, message: message } });
        _controller2.default.sendWebChatToServer({ sid: sid, chat: { name: name, message: message } });
        next();
      });
    });
  });
}

function eventPlayerChat(data, next) {

  // Assert parameters.
  if (!(data && data.id && data.name && data.message)) return next();

  var name = data.name,
      id = data.id,
      message = data.message,
      sid = data.sid;

  _nodebb.db.increment('mi:server:' + sid + ':cid', function (err, cid) {
    _nodebb.db.sortedSetAdd('mi:server:' + sid + ':cid:time', Date.now(), cid, function (err) {
      _nodebb.db.setObject('mi:server:' + sid + ':chat:' + cid, { name: name, message: message }, function (err) {
        _controller2.default.sendPlayerChatToUsers({ sid: sid, chat: { name: name, message: message } });
        next();
      });
    });
  });
}