'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.syncRankGroup = syncRankGroup;
exports.getRanks = getRanks;
exports.getRanksWithMembers = getRanksWithMembers;
exports.setRanks = setRanks;
exports.setRanksWithMembers = setRanksWithMembers;

var _backend = require('./backend');

var _backend2 = _interopRequireDefault(_backend);

var _nodebb = require('./nodebb');

var _nodebb2 = _interopRequireDefault(_nodebb);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Ranks Model

function syncRankGroup(rankName) {
  _backend2.default.getRankGroup(rankName, function (err, groupName) {
    if (err) return;

    if (!groupName) {
      _nodebb2.default.exists(rankName, function (err, exists) {
        if (err) return;

        // If the group doesn't already exist
        if (!exists) {
          _backend2.default.createRankGroup(rankName);
        } else {}
      });
    }
  });
}

function getRanks(sid, callback) {
  _backend2.default.getRanks(sid, function (err, ranks) {
    if (err) return callback(err);

    callback(err, ranks.map(function (rank) {
      return { name: rank };
    }));
  });
}

function getRanksWithMembers(sid, callback) {
  _backend2.default.getRanksWithMembers(sid, callback);
}

function setRanks(sid, ranks, callback) {
  if (!(parseInt(sid, 10) >= 0)) callback(new Error('No sid.'));
  if (!ranks) return callback(new Error('No ranks were submitted.'));

  // TODO: assert params
  _backend2.default.setRanks(sid, ranks, callback);
}

function setRanksWithMembers(sid, ranks, callback) {
  if (!(parseInt(sid, 10) >= 0)) callback(new Error('No sid.'));
  if (!ranks) return callback(new Error('No ranks were submitted.'));

  // TODO: assert params
  _backend2.default.setRanksWithMembers(sid, ranks, callback);
}