'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.render = render;

var _backend = require('../backend');

var _backend2 = _interopRequireDefault(_backend);

var _async = require('async');

var _async2 = _interopRequireDefault(_async);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function render(data, callback) {
  data.show = parseInt(data.show);
  data.show = isNaN(data.show) ? 5 : data.show;
  data.show = data.show > 20 ? 20 : data.show;
  data.show = data.show < 3 ? 3 : data.show;

  data.statname = '';

  // Defaults
  data.useColors = data.useColors || 'a';
  data.colorStart = data.colorStart || 'white';
  data.colorEnd = data.colorEnd || 'white';

  _async2.default.waterfall([_async2.default.apply(_backend2.default.getTopPlayersByPlaytimes, { show: data.show }), function (players, next) {
    _async2.default.map(players, function (player, next) {
      // TODO: Different scoring methods.
      player.score = player.playtimeHuman;

      _backend2.default.getAvatar({ base64: true, name: player.name }, function (err, avatar) {
        player.avatar = avatar;
        next(null, player);
      });
    }, next);
  }], function (err, players) {
    data.players = players;
    callback(null, data);
  });
}